#ifndef MYFFT
#define MYFFT
#include <fftw3.h>
#include <math.h>
#include <string.h>
#include "AUEffectBase.h"
#include "MelodyExtractionVersion.h"

#if AU_DEBUG_DISPATCHER
	#include "AUDebugDispatcher.h"
#endif

#define Float double
#define TWO_PI (M_PI * 2.0)

/*--------------------------------- Global variables --------------------------------------*/

/*-------------------------------- myfft.c functions  -------------------------------------*/

Float mus_linear_to_db(Float x);
Float mus_radians_to_hz(Float rads);
Float mus_hz_to_radians(Float hz);
Float mus_degrees_to_radians(Float degree);
Float mus_radians_to_degrees(Float rads);
Float mus_db_to_linear(Float x);

void Hanning(Float32 *win, int n);
void Blackman92(Float *win, int n);
void Hamhan(Float *win, int n);
void mus_fftw(Float *rl, int n, int dir);
void fourier_spectrum(Float32 sf[], Float32 fft_data[], Float32 fft_phase[], int fft_size, int data_len, Float32 window[], int win_len);
bool isNaN(double val);

#endif
